#ifndef GAMEMANAGER_H
#define GAMEMANAGER_H

#include <SDL.h>
#include <SDL_framerate.h>
#include <SDL_ttf.h>
#include <SDL_mixer.h>

#include "State.h"
#include "SplashState.h"
#include "Level1State.h"
#include "Level2State.h"
#include "TilemapState.h"
#include "InputManager.h"
#include "Level3State.h"
#include "GameOver.h"
#include "Player.h"
#include "SurvivedState.h"

class GameManager
{
    public:
        GameManager();
        virtual ~GameManager();
        void run();
    protected:
    private:
        SDL_Surface* screen;
        FPSmanager* manex;
        State* currentState;
        Uint32 timer;
        int dt;
        int monitorh;
        int monitorw;
        InputManager* inputManager;
        Player* p1;
        Player* p2;
        bool renderPlayer;
};

#endif // GAMEMANAGER_H
