#ifndef INPUTMANAGER_H
#define INPUTMANAGER_H

#include <SDL.h>
#include <list>

#include "Sprite.h"
#include "Text.h"

class InputManager
{
    public:
        InputManager();
        virtual ~InputManager();
        void update();
        bool isKeyDown(int);
        bool isKeyUp(int);
        bool isKeyPressed(int);
        bool isMouseDown(int);
        bool isMouseUp(int);
        bool isMousePressed(int);
        int mousePosx();
        int mousePosy();
        bool isMouseInside(Sprite*);
        bool isMouseInside(Text*);
    protected:
        InputManager* getInstance();
    private:
        Uint8* keyState;
        static InputManager* instance;
        std::list<SDL_Event> events;
        std::list<SDL_Event>::iterator eventsIt;
};

#endif // INPUTMANAGER_H
