#ifndef LEVEL3STATE_H
#define LEVEL3STATE_H

#include "State.h"
#include "Animation.h"
#include <list>

class Level3State : public State
{
    public:
        Level3State();
        virtual ~Level3State();

        void load(Player*, Player*);
        void unload();
        int update(int, InputManager*, Player*, Player*);
        void render(SDL_Surface*, Player*, Player*);
    protected:
    private:
        Sprite* fundo;
        Sprite* muro1;
        Sprite* muro2;
        Sprite* tira;
        Sprite* sangue1;
        Sprite* sangue2;

        Animation* amassado1;
        Animation* amassado2;
        Animation* personagem1;
        Animation* personagem2;
        Animation* sangueMorto1;
        Animation* sangueMorto2;
        Animation* sangueEspinho1;
        Animation* sangueEspinho2;

        Sprite* morte1ant;
        Sprite* morte1dep;
        Sprite* morte2ant;
        Sprite* morte2dep;

        int numero1;
        int numero2;
        bool andando1;
        bool andando2;
        int posAnt1;
        int posAnt2;
        bool bateu;
        bool morreu1;
        bool morreu2;
        int ctrlAnimacao1;
        int ctrlAnimacao2;

        Text* fontes[10];
        Text* text;
        TimeCounter* timeCounter;

        int tempo;
        int danoDado1;
        int danoDado2;

        std::list<Sprite*> sangues;

        Audio* bg;
        Audio* grito;
        Audio* arrastar;
        bool gritar;


};

#endif // LEVEL3STATE_H
