#ifndef SPRITE_H
#define SPRITE_H

#ifdef __APPLE__
#include <SDL/SDL.h>
#else
#include <SDL.h>
#endif
#include <SDL_image.h>

#include <string>
#include <stdlib.h>
#include <SDL_rotozoom.h>

class Sprite
{
    public:
        Sprite(std::string fileName, int x, int y);
        virtual ~Sprite();
        void Render(SDL_Surface*);
        void UpdatePos(int, int);
        SDL_Rect* GetRect();
        bool boxCollidesWith(Sprite*);
        void setZoom(double);
        void setRot(double);

        SDL_Rect* rectangle;
        int x;
        int y;
        SDL_Surface* surface;
        SDL_Rect* rectRotoZoom;
    protected:
    private:
        std::string fileName;
        SDL_Surface* surfaceRotoZoom;
        double angle;
        double zoom;
};

#endif // SPRITE_H
