#ifndef STATE_H
#define STATE_H

#include <SDL.h>

#include "Sprite.h"
#include "InputManager.h"
#include "Audio.h"
#include "Text.h"
#include "TimeCounter.h"
#include "Player.h"
#include <math.h>

class State
{
    public:
        virtual void load(Player*, Player*) = 0;
        virtual void unload() = 0;
        virtual int update(int, InputManager*, Player*, Player*) = 0;
        virtual void render(SDL_Surface*, Player*, Player*) = 0;
    protected:
    private:
};

#endif // STATE_H
