#ifndef TEXT_H
#define TEXT_H

#ifdef __APPLE__
#include <SDL/SDL.h>
#else
#include <SDL.h>
#endif

#include <string>
#include <stdlib.h>
#include <SDL_ttf.h>

class Text
{
    public:
        Text(std::string fontFile, float x, float y, int style, int red, int green, int blue, int psize, std::string);
        virtual ~Text();
        void render(SDL_Surface*);
        void changeText(std::string);
        void changeStyle(int);
        void changeColor(int, int, int);
        void changeSize(int);
        void UpdatePos(int x, int y);

        SDL_Rect rect;
        float x;
        float y;
    protected:
    private:
        TTF_Font* font;
        std::string text;
        std::string fontFile;
        int style;
        SDL_Surface* textSurface;
        SDL_Color color;
        int psize;
};

#endif // TEXT_H
