#include "../include/Animation.h"

Animation::Animation(std::string nomeArq, int x, int y, int frameTime, int nx, int ny, bool praFrente)
{
    surface = IMG_Load(nomeArq.c_str());
    rectangle = new SDL_Rect();
    rectangle->x = x;
    rectangle->y = y;
    rectangle->w = surface->w / nx;
    rectangle->h = surface->h / ny;
    this->frameTime = frameTime;
    this->nx = nx;
    this->ny = ny;
    srcRect = new SDL_Rect();
    srcRect->w = rectangle->w;
    srcRect->h = rectangle->h;
    tempo = 0;
    this->praFrente = praFrente;
    if(nx >= ny) {
        n = nx;
    }
    else {
        n = ny;
    }
}

Animation::~Animation()
{
    //dtor
}

void Animation::update(int dt)
{

    if(praFrente) {
        tempo += dt;
    }
    else {
        tempo -= dt;
        if (tempo < 0) {
            tempo += frameTime * nx * ny;
        }
    }
    tempo %= (frameTime * nx * ny);
    frame = tempo / frameTime;
    srcRect->x = (int) floor(frame % nx) * srcRect->w;
    printf("x: %d\n", srcRect->x);
    srcRect->y = (int) floor(frame / nx) * srcRect->h;
    printf("y: %d\n", srcRect->y);
}

void Animation::render(SDL_Surface* screen)
{
    SDL_BlitSurface(surface, srcRect, screen, rectangle);
}
