#include "../include/Level1State.h"

Level1State::Level1State()
{
    //ctor
}

Level1State::~Level1State()
{
    //dtor
}

void Level1State::load(Player* p1, Player* p2)
{
    timeCounter = new TimeCounter();
    timeCounter->start();
    fundo = new Sprite("fundo1.png", 0, 0);
    arma = new Sprite("arma.png", 0, 0);
    arma->UpdatePos(512 - arma->rectangle->w / 2, 768 - arma->rectangle->h/2);
    mira = new Sprite("target.png", 0, 0);
    balance = new Sprite("balance.png", 192, 100);
    timer = new Sprite("timer.png", 0, 0);
    timer->UpdatePos(512 - timer->rectangle->w/2, 0);
    text = new Text("DS-DIGI.TTF", 0, 0, 0, 255, 0, 0, 30, "0: 10");
    text->UpdatePos(512 - text->rect.w/2, timer->rectangle->h/2 - text->rect.h/2);
    cordaE = new Sprite("chain.png", 0, 0);
    cordaEQuebrada = NULL;
    cordaDQuebrada = NULL;
    cordaD = new Sprite("chain.png", 0, 0);
    cordaE->UpdatePos( balance->x, balance->y + balance->rectangle->h - 10);
    cordaD->UpdatePos(balance->x + balance->rectangle->w - cordaD->rectangle->w, balance->y + balance->rectangle->h - 10);

    gaiolaE = new Sprite("cage.png", 0, 0);
    gaiolaE->UpdatePos(cordaE->x + (cordaE->rectangle->w/2) - (gaiolaE->rectangle->w/2), cordaE->y + cordaE->rectangle->h);
    gaiolaD = new Sprite("cage.png", 0, 0);
    gaiolaD->UpdatePos(cordaD->x + (cordaD->rectangle->w/2) - (gaiolaD->rectangle->w/2), cordaD->y + cordaD->rectangle->h);

    largBalance = balance->rectangle->w;
    yCorda = balance->y + balance->rectangle->h;

    jogadorE = new Sprite("jogador1.png",0, 0);
    jogadorE->UpdatePos(gaiolaE->x + gaiolaE->rectangle->w/2 - jogadorE->rectangle->w/2, gaiolaE->y + gaiolaE->rectangle->h/2 - jogadorE->rectangle->h/2);

    jogadorD = new Sprite("jogador2.png",0, 0);
    jogadorD->UpdatePos(gaiolaD->x + gaiolaD->rectangle->w/2 - jogadorD->rectangle->w/2, gaiolaD->y + gaiolaD->rectangle->h/2 - jogadorD->rectangle->h/2);

    vyE = 0;
    vyD = 0;
    caindoE = false;
    caindoD = false;
    tempo = 0;
    gaiolaQuebradaD = 0;
    gaiolaQuebradaE = 0;
    inicioRot = 0;
    rodando = false;
    atirando = false;
    vaiAcertar = false;
    angulo = 0.0f;
    tempoFinal = 0;

    SDL_ShowCursor(false);

    sangue1 = NULL;
    sangue2 = NULL;

    bg = new Audio("levelstate1.mp3", 0);
    bg->play(-1);
    brokenglass = new Audio("glassshatter.wav",1);
    brokenchain = new Audio("brokenchain.wav",1);
    shot = new Audio("shot.wav",1);
}

void Level1State::unload()
{
    if(fundo) {
        delete fundo;
        fundo = 0;
    }
    if(fundo)
        printf("nao deletou\n");
    if(text) {
        delete text;
        text = 0;
    }
    if(timer) {
        delete timer;
        timer = 0;
    }
    if(balance) {
        delete balance;
        balance = 0;
    }
    if(cordaE) {
        delete cordaE;
        cordaE = 0;
    }
    if(cordaEQuebrada) {
        delete cordaEQuebrada;
        cordaEQuebrada = 0;
    }
    if(gaiolaE) {
        delete gaiolaE;
        gaiolaE = 0;
    }
    if(cordaD) {
        delete cordaD;
        cordaD = 0;
    }
    if(cordaDQuebrada) {
        delete cordaDQuebrada;
        cordaDQuebrada = 0;
    }
    if(gaiolaD) {
        delete gaiolaD;
        gaiolaD = 0;
    }
    if(arma) {
        delete arma;
        arma = 0;
    }
    if(mira) {
        delete mira;
        mira = 0;
    }
    if(balance) {
        delete balance;
        balance = 0;
    }
    if(timeCounter) {
        delete timeCounter;
        timeCounter = 0;
    }
    if(gaiolaQuebradaD) {
        delete gaiolaQuebradaD;
        gaiolaQuebradaD = 0;
    }
    if(gaiolaQuebradaE) {
        delete gaiolaQuebradaE;
        gaiolaQuebradaE = 0;
    }
    if(jogadorE) {
        delete jogadorE;
        jogadorE = 0;
    }
    if(jogadorD) {
        delete jogadorD;
        jogadorD = 0;
    }
}

int Level1State::update(int dt, InputManager* inputManager, Player* p1, Player* p2)
{
    char temp[10];
    int tempo = 30 - (timeCounter->getTime() / 1000);

    mira->UpdatePos(inputManager->mousePosx() - mira->rectangle->w / 2, inputManager->mousePosy() - mira->rectangle->h / 2);

    if((inputManager->isMouseDown(SDL_BUTTON_LEFT)))
    {
        atirando = true;
        shot->play(0);
    }


    //printf("%f \n", angulo);

    //if((inputManager->isMouseDown(SDL_BUTTON_LEFT)) && (arma->rectRotoZoom->x == (512 - arma->rectRotoZoom->w / 2)) && (arma->rectRotoZoom->y == (768 - arma->rectRotoZoom->h/2)))
    if(atirando)
    {
        arma->UpdatePos(-sin(angulo) * 4 * dt + arma->x, -cos(angulo) * 4 * dt + arma->y);
        //printf("atirou! %f %f\n", cos(((double) atan((512.0 - (double) inputManager->mousePosx()) / (768.0 - (double) inputManager->mousePosy()))) * 180 / 3.1415)* 0.1 * dt + arma->x,
        //       sin(((double) atan((512.0 - (double) inputManager->mousePosx()) / (768.0 - (double) inputManager->mousePosy()))) * 180 / 3.1415) * 0.1 * dt - arma->y);
        //printf("%d %d\n", arma->x, arma->y);
        if((arma->x < 0) || (arma->y < 0) || (arma->x + arma->rectangle->w > 1024))
        {
            atirando = false;
        }
    }
    else
    {
        angulo = ((double) atan((512.0 - (double) inputManager->mousePosx()) / (768.0 - (double) inputManager->mousePosy())));
        arma->setRot(angulo * 180 / 3.1415);
        arma->UpdatePos(512 - arma->rectRotoZoom->w / 2, 768 - arma->rectRotoZoom->h/2);
    }

    if(tempo >= 0) {
        int dezena = tempo/10;
        int unidade = tempo % 10;
        if(dezena == 1) {
            if(unidade == 1) {
                sprintf (temp, "0: %d %d", dezena, unidade);
            }
            else {
                sprintf (temp, "0: %d%d", dezena, unidade);
            }
        }
        else {
            if(unidade == 1) {
                sprintf (temp, "0:%d %d", dezena, unidade);
            }
            else {
                sprintf (temp, "0:%d%d", dezena, unidade);
            }
        }
        text->changeText(temp);
    }

//    if(angulo >= 0)
//    {
//        if((768 - tan(1.57 - angulo) * (cordaD->x + cordaD->rectangle->w/2 - 512) >= cordaD->y) && (768 - tan(1.57 - angulo) * (cordaD->x + cordaD->rectangle->w/2 - 512) <= (cordaD->y + cordaD->rectangle->h))
//           && (inputManager->isMouseDown(SDL_BUTTON_LEFT) && !caindoD))
//        {
//            printf("deu pra esquerda\n");
//            vaiAcertar = true;
//            caindoE = true;
//        }
//        if(vaiAcertar && (arma->x <= (cordaE->x + cordaE->rectangle->w)) && (!caindoD))
//            printf("quebre!\n");
//
//    }
//    else
//    {
//        if(((768 - tan(1.57 + angulo) * (cordaD->x + cordaD->rectangle->w/2 - 512)) >= cordaD->y) && (768 - tan(1.57 + angulo) * (cordaD->x + cordaD->rectangle->w/2 - 512) <= (cordaD->y + cordaD->rectangle->h))
//           && (inputManager->isMouseDown(SDL_BUTTON_LEFT) && !caindoE))
//           {
//                printf("deu pra direita\n");
//                vaiAcertar = true;
//                caindoD = true;
//           }
//        if(vaiAcertar && ((arma->x + arma->rectangle->w) >= (cordaD->x)) && (!caindoE))
//            printf("quebre!\n");
//    }


    if((tempo <= 0) && !caindoD && !caindoE) {
        caindoE = true;
        caindoD = true;
    }

    if(gaiolaE) {
//        if((inputManager->isMouseInside(cordaE)) && (inputManager->isMouseDown(SDL_BUTTON_LEFT) && !caindoD)) {
        if(angulo >= 0)
        {
            if((768 - tan(1.57 - angulo) * (cordaD->x + cordaD->rectangle->w/2 - 512) >= cordaD->y) && (768 - tan(1.57 - angulo) * (cordaD->x + cordaD->rectangle->w/2 - 512) <= (cordaD->y + cordaD->rectangle->h))
               && (inputManager->isMouseDown(SDL_BUTTON_LEFT) && !caindoD))
                vaiAcertar = true;

            if(vaiAcertar && (arma->x <= (cordaE->x + cordaE->rectangle->w)) && (!caindoD))
            {
                caindoE = true;
                rodando = true;
                cordaEQuebrada = new Sprite("corrente-quebrada1.png", cordaE->x, cordaE->y);
                delete cordaE;
                brokenchain->play(0);
                cordaE = cordaEQuebrada;
                cordaEQuebrada = new Sprite("corrente-quebrada2.png", 0, 0);
            }
        }

        if(caindoE) {
            vyE += 0.005 * dt;
            gaiolaE->UpdatePos(gaiolaE->x, gaiolaE->y + vyE * dt);
            if(cordaEQuebrada)
                cordaEQuebrada->UpdatePos(gaiolaE->x + gaiolaE->rectangle->w/2 - cordaEQuebrada->rectangle->w/2, gaiolaE->y - cordaEQuebrada->rectangle->h + 5);
        }
        if((gaiolaE->y + gaiolaE->rectangle->h) >= 768) {
            gaiolaQuebradaE = new Sprite("brokencage.png", gaiolaE->x, gaiolaE->y);
            delete gaiolaE;
            gaiolaE = 0;
            brokenglass->play(0);
            rodando = false;
            p1->hp = p1->hp - 20;
//            p1->hp = p1->hp - 100;
            sangue1 = new Sprite("sangue1.png", 0, 0);
            p1->machucado = true;
//            return 3;
        }
    }

    if(gaiolaD) {
        //if((inputManager->isMouseInside(cordaD)) && (inputManager->isMouseDown(SDL_BUTTON_LEFT) && !caindoE)) {
        if(angulo < 0)
        {
            if(((768 - tan(1.57 + angulo) * (cordaD->x + cordaD->rectangle->w/2 - 512)) >= cordaD->y) && (768 - tan(1.57 + angulo) * (cordaD->x + cordaD->rectangle->w/2 - 512) <= (cordaD->y + cordaD->rectangle->h))
               && (inputManager->isMouseDown(SDL_BUTTON_LEFT) && !caindoE))
                vaiAcertar = true;
            if(vaiAcertar && ((arma->x + arma->rectangle->w) >= (cordaD->x)) && (!caindoE))
            {
                caindoD = true;
                rodando = true;
                cordaDQuebrada = new Sprite("corrente-quebrada1.png", cordaD->x, cordaD->y);
                delete cordaD;
                brokenchain->play(0);
                cordaD = cordaDQuebrada;
                cordaDQuebrada = new Sprite("corrente-quebrada2.png", 0, 0);
            }
        }

        if(caindoD) {
            vyD += 0.005 * dt;
            gaiolaD->UpdatePos(gaiolaD->x, gaiolaD->y + vyD * dt);
            if(cordaDQuebrada)
                cordaDQuebrada->UpdatePos(gaiolaD->x + gaiolaD->rectangle->w/2 - cordaDQuebrada->rectangle->w/2, gaiolaD->y - cordaDQuebrada->rectangle->h + 5);
        }
        if((gaiolaD->y + gaiolaD->rectangle->h) >= 768) {
            gaiolaQuebradaD = new Sprite("brokencage.png", gaiolaD->x, gaiolaD->y);
            delete gaiolaD;
            gaiolaD = 0;
            brokenglass->play(0);
            rodando = false;
            p2->hp = p2->hp - 20;
//            p2->hp = p2->hp - 100;
            sangue2 = new Sprite("sangue2.png", 0, 0);
            p2->machucado = true;
//            return 3;
        }
    }

    if(this->tempo < 1600) {

        if (dt + this->tempo > 1600) {
            dt = 1600 - this-> tempo;
        }

        if(caindoD && !caindoE) {
            if(inicioRot == 0)
                inicioRot = dt;
            else
                inicioRot -= dt;
            //printf("%d \n",  (balance->rectRotoZoom->w - largBalance));
            if(rodando)
            {
                balance->setRot(0.1 * (dt - inicioRot));
                cordaD->UpdatePos(balance->x + balance->rectangle->w - cordaD->rectangle->w - (balance->rectRotoZoom->w - largBalance), balance->y + balance->rectangle->h - 10);
                cordaE->UpdatePos(balance->x + balance->rectangle->w - (cos(0.1 *(dt - inicioRot) * 3.14 / 180) * largBalance), yCorda - (balance->y + balance->rectangle->h - yCorda) - 10);
            }
            this->tempo += dt;
        }
        else {
             if(!caindoD && caindoE) {
                if(inicioRot == 0)
                    inicioRot = dt;
                else
                    inicioRot -= dt;
                //printf("%d \n", (balance->rectRotoZoom->w - largBalance));
                if(rodando)
                {
                    balance->setRot(-0.1 * (dt - inicioRot));
                    cordaD->UpdatePos(balance->x - cordaD->rectangle->w + (cos(0.1 *(dt - inicioRot) * 3.14 / 180) * largBalance), yCorda - (balance->y + balance->rectangle->h - yCorda) - 10);
                    cordaE->UpdatePos(balance->x - (balance->rectRotoZoom->w - largBalance), balance->y + balance->rectangle->h - 10);
                }

                this->tempo += dt;
            }
        }

        if(!caindoE)
            gaiolaE->UpdatePos(cordaE->x + cordaE->rectangle->w/2 - gaiolaE->rectangle->w/2, cordaE->y + cordaE->rectangle->h);

        if(gaiolaE)
            jogadorE->UpdatePos(gaiolaE->x + gaiolaE->rectangle->w/2 - jogadorE->rectangle->w/2, gaiolaE->y + gaiolaE->rectangle->h/2 - jogadorE->rectangle->h/2);
        else {
            jogadorE->UpdatePos(gaiolaQuebradaE->x + gaiolaQuebradaE->rectangle->w/2 - jogadorE->rectangle->w/2, gaiolaQuebradaE->y + gaiolaQuebradaE->rectangle->h/2 - jogadorE->rectangle->h/2);
            if(sangue1) {
                sangue1->UpdatePos(jogadorE->x + jogadorE->rectangle->w/2, jogadorE->y + 20);
            }
        }

        if(!caindoD)
            gaiolaD->UpdatePos(cordaD->x + cordaD->rectangle->w/2 - gaiolaD->rectangle->w/2, cordaD->y + cordaD->rectangle->h);

        if(gaiolaD)
            jogadorD->UpdatePos(gaiolaD->x + gaiolaD->rectangle->w/2 - jogadorD->rectangle->w/2, gaiolaD->y + gaiolaD->rectangle->h/2 - jogadorD->rectangle->h/2);
        else {
            jogadorD->UpdatePos(gaiolaQuebradaD->x + gaiolaQuebradaD->rectangle->w/2 - jogadorD->rectangle->w/2, gaiolaQuebradaD->y + gaiolaQuebradaD->rectangle->h/2 - jogadorE->rectangle->h/2);
            if(sangue2) {
                sangue2->UpdatePos(jogadorD->x + jogadorD->rectangle->w/2, jogadorD->y + 20);
            }
        }
    }

    if(!gaiolaD || !gaiolaE) {
        timeCounter->stop();
        if(this->tempoFinal > 2000) {
            return 3;
        }
        else {
            this->tempoFinal += dt;
        }
    }

    return 0;
}

void Level1State::render(SDL_Surface* screen, Player* p1, Player* p2)
{
    fundo->Render(screen);
    cordaE->Render(screen);
    cordaD->Render(screen);

    jogadorE->Render(screen);
    jogadorD->Render(screen);
    if(sangue1) {
        sangue1->Render(screen);
    }
    if(sangue2) {
        sangue2->Render(screen);
    }

    if(gaiolaE) {
        gaiolaE->Render(screen);
    }
    else {
        gaiolaQuebradaE->Render(screen);
    }
    if(gaiolaD) {
        gaiolaD->Render(screen);
    }
    else {
        gaiolaQuebradaD->Render(screen);
    }

    if(cordaEQuebrada)
        cordaEQuebrada->Render(screen);
    if(cordaDQuebrada)
        cordaDQuebrada->Render(screen);

    arma->Render(screen);
    p1->Render(screen);
    p2->Render(screen);
    balance->Render(screen);
    timer->Render(screen);
    text->render(screen);
    mira->Render(screen);
}
