#include "../include/Level3State.h"

Level3State::Level3State()
{

}

Level3State::~Level3State()
{
    //dtor
}



void Level3State::load(Player* p1, Player* p2)
{
    char numero[1];

    fundo = new Sprite("fundo3.png", 0, 0);
    amassado1 = new Animation("amassado1.png", 0, 400, 100, 5, 1, true);
    amassado2 = new Animation("amassado2.png", 0, 400, 100, 5, 1, false);
    amassado2->rectangle->x = 1024 - amassado2->rectangle->w;

    sangueMorto1 = new Animation("sanguemorto1.png", amassado1->rectangle->x, amassado1->rectangle->y + amassado1->rectangle->h - 20, 100, 1, 5, true);
    sangueMorto2 = new Animation("sanguemorto2.png", 0, amassado2->rectangle->y + amassado2->rectangle->h - 20, 100, 1, 5, true);
    sangueMorto2->rectangle->x = 1024 - sangueMorto2->rectangle->w;

    tira = new Sprite("black.jpg", 40, 205);

    personagem1 = new Animation("sprite_sheet.png", 12, 400, 200, 6, 1, true);
    personagem2 = new Animation("sprite_sheet2.png", 0, 400, 200, 6, 1, false);
    personagem2->rectangle->x = 1024 - personagem2->rectangle->w - 12;

    muro1 = new Sprite("wall1.png", 0, 0);
    muro2 = new Sprite("wall2.png", 0, 0);
    muro1->UpdatePos(personagem1->rectangle->x + personagem1->rectangle->w - 27, personagem1->rectangle->y + personagem1->rectangle->h - muro1->rectangle->h);
    muro2->UpdatePos(personagem2->rectangle->x - muro2->rectangle->w + 27, personagem2->rectangle->y + personagem2->rectangle->h - muro2->rectangle->h);
    sangueEspinho1 = new Animation("sangueespinho1.png", muro1->x + 10, muro1->y + 180, 300, 6, 1, true);
    sangueEspinho2 = new Animation("sangueespinho2.png", muro2->x + muro2->rectangle->w - 45, muro2->y + 180, 300, 6, 1, true);

    int x = 62;
    for(int i = 0; i < 10; i++)
    {
        sprintf(numero, "%d", (i+1) % 10);
        fontes[i] = new Text("m06.TTF", 0, 0, 0, 255, 0, 0, 55, numero);
        fontes[i]->UpdatePos(x - fontes[i]->rect.w/2, 204);
        x += 100;
    }

    numero1 = 2;
    numero2 = 9;
    fontes[1]->changeColor(48, 220, 48);
    fontes[8]->changeColor(255, 170, 2);

    andando1 = false;
    andando2 = false;

    posAnt1 = 100;
    posAnt2 = 824;

    bateu = false;

    morreu1 = false;
    morreu2 = false;

    ctrlAnimacao1 = 0;
    ctrlAnimacao2 = 0;

    text = new Text("DS-DIGI.TTF", 0, 0, 0, 255, 0, 0, 35, "0:20");
    text->UpdatePos(512 - text->rect.w/2, 100);
    timeCounter = new TimeCounter();
    timeCounter->start();

    tempo = 0;
    danoDado1 = 0;
    danoDado2 = 0;

    morte1ant = NULL;
    morte1dep = NULL;
    morte2ant = NULL;
    morte2dep = NULL;

    srand(time(NULL));

    bg = new Audio("levelstate3.mp3", 0);
    bg->play(-1);
    grito = new Audio("fallscream.wav",1);
    arrastar = new Audio("arrastar.wav",1);
    gritar = false;
}

void Level3State::unload()
{
    delete bg;
}

int Level3State::update(int dt, InputManager* inputManager, Player* p1, Player* p2)
{
    char temp[10];
    int tempo = 50 - (timeCounter->getTime() / 1000);

    if(tempo >= 0) {
        int dezena = tempo/10;
        int unidade = tempo % 10;
        if(dezena == 1) {
            if(unidade == 1) {
                sprintf (temp, "0: %d %d", dezena, unidade);
            }
            else {
                sprintf (temp, "0: %d%d", dezena, unidade);
            }
        }
        else {
            if(unidade == 1) {
                sprintf (temp, "0:%d %d", dezena, unidade);
            }
            else {
                sprintf (temp, "0:%d%d", dezena, unidade);
            }
        }
        text->changeText(temp);
    }

    if(tempo <= 0/* && !morreu1 && !morreu2*/)
    {
        if(muro1->x >= 0) {
            muro1->x -= dt;
            personagem1->rectangle->x -= dt;
        }

        if(muro2->x <= 1024 - muro2->rectangle->w) {
            muro2->x += dt;
            personagem2->rectangle->x += dt;
        }
    }
    else{
        if(numero2 == (numero1 + 1) && !andando1 && !andando2) {
            bateu = true;
        }
        if((numero2 == (numero1 + 2)) && andando1 && andando2 && (personagem1->rectangle->x + 400 >= personagem2->rectangle->x + personagem2->rectangle->w)) {
            bateu = true;
            if((personagem1->rectangle->x - 12) % 50 > 25) {
                andando1 = false;
                numero1++;
            }
            else {
                andando2 = false;
                numero2--;
            }
        }

        if(!morreu1 && !morreu2 && (tempo > 0)) {

            if(inputManager->isKeyDown(SDLK_0 + numero1) && !andando1) {
                if(!(((inputManager->isKeyDown(SDLK_0 + numero2) && !andando2) || andando2) && bateu) && (p1->hp > 0)) {
                    andando1 = true;
                    arrastar->play(0);
                    posAnt1 = personagem1->rectangle->x;
                }
            }

            if(andando1) {
                personagem1->rectangle->x += dt / 10;
                personagem1->update(dt);
                muro1->x += dt / 10;
                if(((personagem1->rectangle->x - posAnt1) / 20) > danoDado1) {
                    p1->hp -= ((personagem1->rectangle->x - posAnt1) / 20) - danoDado1;
                    danoDado1 = (personagem1->rectangle->x - posAnt1) / 20;
                }
                if(bateu) {
                    personagem2->rectangle->x += dt / 10;
                    muro2->x += dt / 10;
                }
                if(((personagem1->rectangle->x - posAnt1) >= 100) || (muro2->x + muro2->rectangle->w > 1024)) {
                    danoDado1 = 0;
                    andando1 = false;
                    fontes[numero1-1]->changeColor(255, 0, 0);
                    numero1++;
                    fontes[numero1-1]->changeColor(48, 220, 48);
                    numero1 %= 10;
                    if(bateu) {
                        numero2++;
                        fontes[numero2-1]->changeColor(255, 170, 2);
                        numero2 %= 10;
                    }
                }
            }

            if(inputManager->isKeyDown(SDLK_0 + numero2) && !andando2) {
                if(!(((inputManager->isKeyDown(SDLK_0 + numero1) && !andando1) || andando1) && bateu) && (p2->hp > 0)) {
                    andando2 = true;
                    arrastar->play(0);
                    posAnt2 = personagem2->rectangle->x;
                }
            }

            if(andando2) {
                personagem2->rectangle->x -= dt / 10;
                personagem2->update(dt);
                muro2->x -= dt / 10;
                if(((posAnt2 - personagem2->rectangle->x) / 20) > danoDado2) {
                    p2->hp -= ((posAnt2 - personagem2->rectangle->x) / 20) - danoDado2;
                    danoDado2 = (posAnt2 - personagem2->rectangle->x) / 20;
                }
                if(bateu) {
                    personagem1->rectangle->x -= dt / 10;
                    muro1->x -= dt / 10;
                }
                if(((posAnt2 - personagem2->rectangle->x) >= 100) || (muro1->x < 0)) {
                    danoDado2 = 0;
                    andando2 = false;
                    fontes[numero2-1]->changeColor(255, 0, 0);
                    numero2--;
                    fontes[numero2-1]->changeColor(255, 170, 2);
                    numero2 %= 10;
                    if(bateu) {
                        numero1--;
                        fontes[numero1-1]->changeColor(48, 220, 48);
                        numero1 %= 10;
                    }
                }
            }

        }

    }

    if(personagem1->rectangle->x < 0) {
        personagem1->rectangle->x = 0;
    }
    if(personagem2->rectangle->x + personagem2->rectangle->w > 1024) {
        personagem2->rectangle->x = 1024 - personagem2->rectangle->w;
    }

    if(muro1->x < 0) {
        muro1->UpdatePos(0, muro1->y);
        morreu1 = true;
        if(bateu && (tempo > 0)) {
            muro2->UpdatePos(muro1->rectangle->w, muro2->y);
        }
    }
    if(muro2->x + muro2->rectangle->w > 1024) {
        muro2->UpdatePos(1024 - muro2->rectangle->w, muro2->y);
        morreu2 = true;
        if(bateu && (tempo > 0)) {
            muro1->UpdatePos(muro2->x - muro1->rectangle->w, muro1->y);
        }

    }

    if(ctrlAnimacao1 + dt < 500 && morreu1) {
        amassado1->update(dt);
        sangueMorto1->update(dt);
        ctrlAnimacao1 += dt;
        if(p1->hp > 120 - (0.24 * ctrlAnimacao1)) {
            p1->hp = 120 - (0.24 * ctrlAnimacao1);
        }
    }
    else {
        if(ctrlAnimacao1 + dt >= 500 && morreu1) {
            p1->hp = 0;
        }
    }
    if(ctrlAnimacao2 + dt < 500 && morreu2) {
        amassado2->update(dt);
        sangueMorto2->update(dt);
        ctrlAnimacao2 += dt;
        if(p2->hp > 120 - (0.24 * ctrlAnimacao2)) {
            p2->hp = 120 - (0.24 * ctrlAnimacao2);
        }
    }
    else {
        if(ctrlAnimacao2 + dt >= 500 && morreu2) {
            p2->hp = 0;
        }
    }

    if(morreu1 || morreu2) {
        if(!gritar)
        {
            grito->play(0);
            gritar = true;
        }
        timeCounter->stop();
        if(this->tempo > 2000) {
            if(morreu1 && morreu2) {
                return 5;
            }
            else {
                if(!morreu1 && morreu2) {
                    return 6;
                }
                else {
                    return 7;
                }
            }
        }
        else {
            this->tempo += dt;
        }
    }

    if(p1->hp < 0) {
        p1->hp = 0;
    }

    if(p2->hp < 0) {
        p2->hp = 0;
    }

    if((p1->hp == 0) && (p2->hp == 0) && (tempo >= 1)) {
        if(timeCounter->ff == 1) {
            timeCounter->fastForward(10);
        }
    }

    if((sangues.size() / 2) < (50 - tempo)) {
        switch(rand() % 4)
        {
            case 0:
                sangues.push_front(new Sprite("sangueandando1.png",personagem1->rectangle->x, personagem1->rectangle->y + personagem1->rectangle->h - 15));
                sangues.push_front(new Sprite("sangueandando1.png",personagem2->rectangle->x, personagem2->rectangle->y + personagem2->rectangle->h - 15));
            break;
            case 1:
                sangues.push_front(new Sprite("sangueandando2.png",personagem1->rectangle->x, personagem1->rectangle->y + personagem1->rectangle->h - 15));
                sangues.push_front(new Sprite("sangueandando2.png",personagem2->rectangle->x, personagem2->rectangle->y + personagem2->rectangle->h - 15));
            break;
            case 2:
                sangues.push_front(new Sprite("sangueandando3.png",personagem1->rectangle->x, personagem1->rectangle->y + personagem1->rectangle->h - 15));
                sangues.push_front(new Sprite("sangueandando3.png",personagem2->rectangle->x, personagem2->rectangle->y + personagem2->rectangle->h - 15));
            break;
            case 3:
                sangues.push_front(new Sprite("sangueandando4.png",personagem1->rectangle->x, personagem1->rectangle->y + personagem1->rectangle->h - 15));
                sangues.push_front(new Sprite("sangueandando4.png",personagem2->rectangle->x, personagem2->rectangle->y + personagem2->rectangle->h - 15));
            break;
        }
    }

    sangueEspinho1->rectangle->x = muro1->x + 10;
    sangueEspinho2->rectangle->x = muro2->x + muro2->rectangle->w - 45;

    sangueEspinho1->update(dt);
    sangueEspinho2->update(dt);

    return 0;
}

void Level3State::render(SDL_Surface* screen, Player* p1, Player* p2)
{
    fundo->Render(screen);
    tira->Render(screen);
    for (int i = 0; i < 10; i++)
        fontes[i]->render(screen);

    for(int i = 0; i < (int) sangues.size(); i++) {
        Sprite* aux = sangues.front();
        sangues.pop_front();
        aux->Render(screen);
        sangues.push_back(aux);
    }

    if(!morreu1) {
        sangueEspinho1->render(screen);
        personagem1->render(screen);
    }
    else {
        sangueMorto1->render(screen);
        amassado1->render(screen);
    }

    if(!morreu2) {
        sangueEspinho2->render(screen);
        personagem2->render(screen);
    }
    else {
        sangueMorto2->render(screen);
        amassado2->render(screen);
    }

    muro1->Render(screen);
    muro2->Render(screen);
    text->render(screen);
    p1->Render(screen);
    p2->Render(screen);
}
