#include "../include/Tilemap.h"

Tilemap::Tilemap(std::string tileset, int nx, int ny, int w, int h, std::string map)
{
    surface = IMG_Load(tileset.c_str());
    rectangle = new SDL_Rect();
    rectangle->x = 0;
    rectangle->y = 0;
    rectangle->w = w;
    rectangle->h = h;
    srcRect = new SDL_Rect();
    srcRect->w = w;
    srcRect->h = h;
    this->map = fopen(map.c_str(), "r");
    this->nx = nx;
    this->ny = ny;
    this->w = w;
    this->h = h;
    mapPronto = 0;
}

Tilemap::~Tilemap()
{
    //dtor
}

void Tilemap::render(SDL_Surface* screen)
{
    int n;
    char c = ' ';

    if(mapPronto == 0) {
        fscanf(map, "%d", &n);
        while(c != EOF) {
            srcRect->x = (surface->w / nx) * (n % nx);
            srcRect->y = (surface->h / ny) * (n / ny);
            SDL_BlitSurface(surface, srcRect, screen, rectangle);
            fscanf(this->map, "%d", &n);
            if(c == '\n') {
                rectangle->x = 0;
                rectangle->y += h;
            }
            else {
                rectangle->x += w;
            }
            c = fgetc(this->map);
        }
        srcRect->x = (surface->w / nx) * (n % nx);
        srcRect->y = (surface->h / ny) * (n / ny);
        SDL_BlitSurface(surface, srcRect, screen, rectangle);
        fclose(map);
        map = NULL;
        mapPronto = 1;
    }
}
