#include "../include/TimeCounter.h"

TimeCounter::TimeCounter()
{
    paused = true;
    ff = 1;
}

TimeCounter::~TimeCounter()
{
    //dtor
}

void TimeCounter::start()
{
    paused = false;
    initialTime = SDL_GetTicks();
}

void TimeCounter::stop()
{
    if(!paused) {
        paused = true;
        pauseTime = SDL_GetTicks();
    }
}

void TimeCounter::resume()
{
    paused = false;
    initialTime += (SDL_GetTicks() - pauseTime);
}

int TimeCounter::getTime()
{
    if(paused){
        if(ff == 1) {
            return (pauseTime - initialTime);
        }
        else {
            int x = (ffTime - initialTime) + ((pauseTime - ffTime) * ff);
            return ((ffTime - initialTime) + ((pauseTime - ffTime) * ff));
        }
    }
    else{
        if(ff == 1) {
            return (SDL_GetTicks() - initialTime);
        }
        else {
            return ((ffTime - initialTime) + ((SDL_GetTicks() - ffTime) * ff));
        }
    }
}

void TimeCounter::fastForward(int mult)
{
    ffTime = SDL_GetTicks();
    ff = mult;
}
